<?php
	function test()
	{
		if(file_exists("../backend/password.php"))
		{
			return true;
		}
		return false;
	}
	
	function fix_broken_webhosts_shiznit()
	{
		$returns=array(0,0);
		$files=glob("*-*.php");
		if($files !== false)
		{
			foreach($files as $file)
			{
				$name=explode("-",$file);
				if(count($name) == 2)
				{
					rename($file,$name[0] . "/" . $name[1]);
					if(file_exists($name[0] . "/" . $name[1]))
					{
						$returns[0]++;
					}
					else
					{
						$returns[1]++;
					}
				}
				else
				{
					$returns[1]++;
				}
			}
			return $returns;
		}
		else
		{
			return false;
		}
	}
	
	function rewrite_posts()
	{
		$returns=array(0,0,0,0);
		$files=glob("../posts/*.txt");
		foreach($files as $file)
		{
			$debug=copy($file,"../archive/" . basename($file));
			if($debug === true)
			{
				$returns[0]++;
				$contents=explode("\r\n",base64_decode(file_get_contents($file)));
				if(strpos($contents[4],"|") === false && strpos($contents[4],"custom**") === false)
				{
					$debug=preg_match("/(.+)\-(.+) \(from the album (.+)?, (.+)?\)/",$contents[4],$matches);
					if($debug !== false)
					{
						if(count($matches) >= 3)
						{
							$contents[4]="artist=" . $matches[1] . "|title=" . $matches[2];
                            if(isset($matches[3]))
                            {
                                $contents[4].="|album=" . $matches[3];
                            }
                            if(isset($matches[4]))
                            {
                                $contents[4].="|year=" . $matches[4];
                            }
						}
						else
						{
							$contents[4]="custom**=" . $contents[4];
						}
						$contents=base64_encode(implode("\r\n",$contents));
						$fh=fopen($file,'w');
						if($fh)
						{
							fwrite($fh,$contents);
							fclose($fh);
							$returns[2]++;
						}
						else
						{
							$returns[3]++;
						}
					}
				}
			}
			else
			{
				$returns[1]++;
			}
		}
		return $returns;
	}
	
	function fix_date()
	{
		$returns=array(0,0,0,0);
		$files=glob("../posts/*.txt");
		foreach($files as $file)
		{
			$debug=copy($file,"../archive/" . basename($file));
			if($debug === true)
			{
				$returns[0]++;
				$contents=explode("\r\n",base64_decode(file_get_contents($file)));
				if(ctype_digit($contents[3]) === true)
				{
					$contents[3]=date("m/d/Y g:i A",$contents[3]);
					$contents=base64_encode(implode("\r\n",$contents));
					$fh=fopen($file,'w');
					if($fh)
					{
						fwrite($fh,$contents);
						fclose($fh);
						$returns[2]++;
					}
					else
					{
						$returns[3]++;
					}
				}
			}
			else
			{
				$returns[1]++;
			}
		}
		return $returns;
	}
	
	function postprocessor_run()
	{
		if(test() === false)
		{
			//Include doesn't exist
			return -183;
		}
		if(!function_exists("password_hash") || !function_exists("password_get_info"))
		{
			//Run include
			include("../backend/password.php");
		}
		if(!function_exists("password_hash") || !function_exists("password_get_info"))
		{
			//Include didn't work
			return -283;
		}
		//Get the system password
		if(file_exists("../backend/password.txt"))
		{
			$pass=base64_decode(file_get_contents("../backend/password.txt"));
		}
		else
		{
			//Error
			return -281;
		}
		//Check the hash details
		$details=password_get_info($pass);
		if($details['algo'] != 0)
		{
			echo("Password is already up to date, skipping. ");
		}
        else
        {
            //Hash the default password
            $newpass=base64_encode(password_hash("admin",PASSWORD_DEFAULT));
            //Write the new password
            $fh=fopen("../backend/password.txt",'w');
            if($fh)
            {
                fwrite($fh,$newpass);
                echo("Password is reset to default. ");
                fclose($fh);
            }
            else
            {
                //Could not write new password
                echo("Cannot reset password. You will be locked out if you log out. ");
                return -282;
            }
        }
		$debug=fix_broken_webhosts_shiznit();
		if($debug !== false && count($debug) == 2)
		{
			if($debug[0] > 0 || $debug[1] > 0)
			{
				echo("Fixed " . $debug[0] . " files with " . $debug[1] . " errors. ");
			}
			if($debug[1] > 0)
			{
				return -301;
			}
		}
		else
		{
			return -300;
		}
		$debug=rewrite_posts();
		if($debug !== false && count($debug) == 4)
		{
			if($debug[0] > 0 || $debug[1] > 0)
			{
				echo("Backed " . $debug[0] . " posts up to \"archive\" with " . $debug[1] . " errors. ");
			}
			if($debug[2] > 0 || $debug[3] > 0)
			{
				echo("Reformatted " . $debug[2] . " posts with " . $debug[3] . " errors. ");
			}
			if($debug[1] > 0)
			{
				return -404;
			}
			if($debug[3] > 0)
			{
				return -410;
			}
		}
		else
		{
			return -400;
		}
		$debug=fix_date();
		if($debug !== false && count($debug) == 4)
		{
			if($debug[0] > 0 || $debug[1] > 0)
			{
				echo("Backed " . $debug[0] . " posts up to \"archive\" with " . $debug[1] . " errors. ");
			}
			if($debug[2] > 0 || $debug[3] > 0)
			{
				echo("Reformatted the date in " . $debug[2] . " posts with " . $debug[3] . " errors. ");
			}
			if($debug[1] > 0)
			{
				return -403;
			}
			if($debug[3] > 0)
			{
				return -418;
			}
			else
			{
				return true;
			}
		}
		else
		{
			return -401;
		}
		//Shouldn't get here, but just in case
		return -999;
	}
?>