<?php
	function make_api_dir()
	{
		//Check if api folder exists
		if(file_exists("../api") && is_dir("../api"))
		{
			return true;
		}
		//Make new folder
		$debug=@mkdir("../api");
		if($debug === true)
		{
			//Copy index page from backend into new directory
			$debug=@copy("../backend/index.html","../api/index.html");
			if($debug === true)
			{
				echo("Created new folder \"api\". ");
			}
			//Error occurred while copying
			return -173;
		}
		//Error occurred while creating directory
		return -183;
	}
	
	function make_error_dir()
	{
		//Check if error folder exists
		if(file_exists("../error") && is_dir("../error"))
		{
			return true;
		}
		//Make new folder
		$debug=@mkdir("../error");
		if($debug === true)
		{
			//Copy index page from backend into new directory
			$debug=@copy("../backend/index.html","../error/index.html");
			if($debug === true)
			{
				echo("Created new folder \"error\". ");
				//All successful
				return true;
			}
			//Error occurred while copying
			return -273;
		}
		//Error occurred while creating directory
		return -283;
	}
	
	function make_song_dir()
	{
		//Check if error folder exists
		if(file_exists("../songs") && is_dir("../songs"))
		{
			return true;
		}
		//Make new folder
		$debug=@mkdir("../songs");
		if($debug === true)
		{
			//Copy index page from backend into new directory
			$debug=@copy("../backend/index.html","../songs/index.html");
			if($debug === true)
			{
				echo("Created new folder \"songs\". ");
				//All successful
				return true;
			}
			//Error occurred while copying
			return -373;
		}
		//Error occurred while creating directory
		return -383;
	}
	
	function regen_song_list()
	{
		$songlist="";
		if(file_exists("../backend/songlist.txt"))
		{
			//Get song list
			$songlist=explode("\r\n",file_get_contents("../backend/songlist.txt"));
			if(file_exists("../backend/baselist.txt"))
			{
				//Get base list
				$baselist=explode("\r\n",file_get_contents("../backend/baselist.txt"));
			}
			else
			{
				//No base list present
				$baselist=array();
				$bm=0;
			}
			//Get file modification time for song list
			$sm=filemtime("../backend/songlist.txt");
			//Set modification time for base list to be song list less a week
			$bm=$sm-(7*24*60*60);
			//Remove duplicates
			$songlist=array_diff($songlist,$baselist);
			//Re-key resulting array
			$songlist=array_values($songlist);
			//Modify lists to include modification times
			for($i=0;$i<count($baselist);$i++)
			{
				$baselist[$i]=$bm . "|" . $baselist[$i];
			}
			for($i=0;$i<count($songlist);$i++)
			{
				$songlist[$i]=$sm . "|" . $songlist[$i];
			}
			//Merge lists
			$songlist=array_merge($songlist,$baselist);
			//Merge new list into string
			$songlist=implode("\r\n",$songlist);
		}
		echo("Generated new song list. ");
		return $songlist;
	}
	
	function write_new_song_list($list)
	{
		//Open list
		$fh=fopen("../songs/main.txt",'w');
		if($fh)
		{
			//Write list to file
			fwrite($fh,$list);
			fclose($fh);
			echo("Wrote new song list to file. ");
			return true;
		}
		//Error writing file
		return -483;
	}
	
	function preprocessor_run()
	{
		$debug=make_api_dir();
		if($debug === true)
		{
			$debug=make_error_dir();
			if($debug === true)
			{
				$debug=make_song_dir();
				if($debug === true && !file_exists("../songs/main.txt"))
				{
					$debug=write_new_song_list(regen_song_list());
				}
			}
		}
		return $debug;
	}
?>